#include "DeerStudio/EditorEngine/API/EditorEngine_Environment.h"
#include "DeerStudio/Project.h"
#include "Deer/Enviroment.h"
#include "DeerStudio/EditorEngine.h"
#include "DeerStudio/EditorEngine/DockPanelObject.h"
#include "Deer/Scene.h"

namespace Deer {
    namespace EditorEngine {
        EntityStruct getRoot() {
            return EntityStruct(0);
        }
        
        int EntityStruct::getChildCount() {
            return Project::m_scene
                .getMainEnviroment()
                .getEntity(entityId)
                .getComponent<RelationshipComponent>()
                .childCount;
        }

        EntityStruct EntityStruct::getChild(int i) {
            RelationshipComponent& rc = Project::m_scene
                .getMainEnviroment()
                .getEntity(entityId)
                .getComponent<RelationshipComponent>();

            if (i < 0 || i >= rc.childCount) {
                DEER_UI_ENGINE_ERROR("Error while executing Entity.getChild(..), id {0} is invalid for child count of {1}", i, rc.childCount);
                if (currentDockPanelExecution)
                    currentDockPanelExecution->invalidate();

                return EntityStruct(0);
            }

            return EntityStruct(rc.getChildrenId(i));
        }

        void constructEntityStruct(int id, void* memory) {
            new (memory)EntityStruct(id);
        }

        int EntityStruct::getId() {
            return entityId;
        }

        std::string EntityStruct::getName() {
            return Project::m_scene
                .getMainEnviroment()
                .getEntity(entityId)
                .getComponent<TagComponent>()
                .tag;
        }
    }
}