#include "DeerStudio/EditorEngine/API/EditorEngine_TreeNode.h"
#include "DeerStudio/EditorEngine/EditorEngine_ErrorHandle.h"
#include "DeerStudio/EditorEngine.h"
#include "angelscript.h"
#include "scriptany.h"
#include "imgui.h"

namespace Deer {
    namespace EditorEngine {
        void treeNode(std::string& txt, int id) {
            ImGuiTreeNodeFlags flags = ImGuiTreeNodeFlags_Leaf |
			                           ImGuiTreeNodeFlags_NoTreePushOnOpen |
			                           ImGuiTreeNodeFlags_SpanFullWidth;

            ImGui::TreeNodeEx((void*)(long long)id, flags, "%s", txt.c_str());
        }

        void treeNodeRecursive(std::string& txt, int id, CScriptAny *data, asIScriptFunction& func) {
            ImGuiTreeNodeFlags flags = ImGuiTreeNodeFlags_OpenOnDoubleClick |
                                       ImGuiTreeNodeFlags_OpenOnArrow |
                                       ImGuiTreeNodeFlags_SpanFullWidth;

            if (ImGui::TreeNodeEx((void*)(long long)id, flags, "%s", txt.c_str())) {
                ImGui::PushID(id);
                if (scriptContext && scriptContext->PushState() == asSUCCESS) {
                    AS_CHECK_ADDITIONAL_INFO(
                        scriptContext->Prepare(&func),
                        func.GetDeclaration()
                    );

                    AS_CHECK_ADDITIONAL_INFO(
                        scriptContext->SetArgObject(0, data),
                        func.GetDeclaration()
                    );
    
                    AS_CHECK_ADDITIONAL_INFO(
                        scriptContext->Execute(),
                        func.GetDeclaration()
                    );
    
                    scriptContext->PopState();
                } else {
                    ImGui::Text("Something failed");
                }


                ImGui::PopID();
                ImGui::TreePop();
            }
        }
    }
}