#include "DeerStudio/EditorEngine.h"
#include "scripthandle.h"
#include "scriptany.h"
#include "DeerStudio/EditorEngine/EditorEngine_ErrorHandle.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Mesh.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Environment.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Directory.h"
#include "angelscript.h"

namespace Deer {
    namespace EditorEngine { 
        void registerResourceTypeEnum() {
            AS_RET_CHECK(scriptEngine->RegisterEnum("ResourceType"));
            AS_CHECK(scriptEngine->RegisterEnumValue("ResourceType", "Mesh", (int)ResourceType::MESH));
        }

        void registerEntityStruct() {
            AS_CHECK(scriptEngine->RegisterObjectType("Entity", sizeof(EntityStruct), 
                asOBJ_VALUE | asOBJ_POD | asGetTypeTraits<EntityStruct>() | asOBJ_APP_CLASS_ALLINTS));


            AS_CHECK(scriptEngine->RegisterObjectBehaviour(
                "Entity",
                asBEHAVE_CONSTRUCT,
                "void f(int)",
                asFunctionPtr(constructEntityStruct),
                asCALL_CDECL_OBJLAST
            ));
        }

        void registerEditorEngineStructs() {
            RegisterScriptHandle(scriptEngine);
            RegisterScriptAny(scriptEngine);

            registerResourceTypeEnum();
            registerEntityStruct();
        }
    }
}